#
# STM specific device configuration
#

config STM_DRIVERS
	boolean
	default y if CPU_SUBTYPE_ST40
	default n

menu "STM specific devices"
        depends on STM_DRIVERS

config STM_PIO
	tristate "STMicroelectronics PIO Support"
	depends on CPU_SUBTYPE_ST40
	default y
	help
	  Driver for the PIO pins on STMicroelectronics ST40 and ST200
	  based parts.

config STM_PIO10
	bool
	depends on STM_PIO
	default n

config STM_DMA
	bool "STMicroelectronics DMA API"
	select SH_DMA_API
	default y
	---help---
	  Selecting this option will provide support for STMicroelectronics'
	  custom DMA API. This API provides support for data transfers of
	  various dimensions and complex linked list operations. In addition
	  to these free-running operations it also allows management of the
	  paced-transfer peripherals on recent STM parts.

	  On STb710x and STx7200 DMA support is vital for the correct operation of the
	  sound system.

	  If you have a device from STMicroelectronics, then say Y here.
	  Otherwise say N.

config MIN_STM_DMA_CHANNEL_NR
	depends on STM_DMA
	int "Lowest STM-FDMAC channel"
	default "0"
	help
	  This allows you to specify the low boundary FDMA channel number to
	  use with STM-DMA

config MAX_STM_DMA_CHANNEL_NR
	depends on STM_DMA
	int "Highest STM-FDMAC channel"
	default "15"
	help
	  This allows you to specify the high boundary FDMA channel number to
	  use with STM-DMA

config STM_DMA_DEBUG
	bool "STMicroelectronics DMA Debug"
	depends on STM_DMA
	default n

choice
	prompt "FDMA firmware loading strategy"
	depends on STM_DMA
	default STM_DMA_FW_KERNEL

config  STM_DMA_FW_USERSPACE
	depends on EXPERIMENTAL
	bool "Use hotplug firmware loading framework (EXPERIMENTAL)"

config STM_DMA_FW_KERNEL
	bool "Use firmware linked into the kernel image"

endchoice

config STM_COPROCESSOR_SUPPORT
	bool "STMicroelectronics coprocessor support"
	default y
	depends on CPU_SUBTYPE_STB7100 || CPU_SUBTYPE_STX7105 || CPU_SUBTYPE_STX7111 || CPU_SUBTYPE_STX7141 || CPU_SUBTYPE_STX7200
	---help---
        Many of the ST system-on-chip devices have multiple CPUs, where a
        master CPU running Linux has control over a number of slave CPUs,
        which are usually used to run dedicated algorithms.
        Enabling this option will add support to the Linux kernel to
        control these slave CPUs, reserve memory for them, and thus allow
        code to be downloaded onto them and executed.
        Adding in the command line the following string:
        coprocessor_mem=[offset]:size0[,size1][,size2]...
        where:
        offset defines where the co-processors region starts.
               It's an offset from ST40 RAM start.
        size{n} defines the region size for the n.th slave core (max 16M).

        Example: coprocessor_mem=32m:16m,16m

config STM_NUM_COPROCESSOR
	int
	depends on STM_COPROCESSOR_SUPPORT
	default 2 if CPU_SUBTYPE_STB7100
	default 2 if CPU_SUBTYPE_STX7105
	default 2 if CPU_SUBTYPE_STX7111
	default 2 if CPU_SUBTYPE_STX7141
	default 4 if CPU_SUBTYPE_STX7200
	default 0

choice
	prompt "STM coprocessor loading strategy"
        depends on STM_COPROCESSOR_SUPPORT
        default STM_COPROCESSOR

config  STM_COPROCESSOR
	bool "STM coprocessor support"
	help
	  Select this option to enable support for the slave coprocessors
	  found on many ST system-on-chip devices.

config  STM_COPROCESSOR_FRMW
	bool "The new STM coprocessor firmware support "
	select FW_LOADER
	help
	  Select this option to enable support for the slave coprocessors
	  found on many ST system-on-chip devices.

endchoice

config  COPROCESSOR_DEBUG
        depends on STM_COPROCESSOR_SUPPORT
        bool "STM coprocessor debug"
        default n
        ---help---
        Enable this option to print out information about the slave CPUs
        addresses and operations you are using for coprocessor.

config STM_RNG
       depends on CPU_SUBTYPE_ST40
       bool "STM Random Number Generator Support"
       default y
       ---help---
         This option adds support for the hardware Random Number Generator
          (RNG) present on the STx71xx and STx7200 SoCs.  It allows the
         RNG to feed /dev/random with entropy thereby ensuring real
         random numbers from this device.

         Without this option, /dev/random has little entropy and is not
         useful.  In fact, it may block for a long time while waiting for
         entropy.

         This option should always be enabled for the STx71xx and STx7200
         SoCs.

          This option can be used in conjunction with the /dev/hw_random
          driver found in the char drivers menu.

config STM_LPC
	depends on STM_DRIVERS
	bool "STM Low Power Controller"
	default n
	---help---
	  This option adds support for the hardware low power controller.

config STM_LPC_DEBUG
	depends on STM_LPC
	bool "STM Low Power Controller debug"
	default n
	---help---
	  Enable this option to print out information about the LPC

config PMS
	bool "Power Management Scheme"
	default n
	depends on PM
	help
	  This option enables the power management scheme on clocks and devices system

config PMS_CHECK_GROUP
	bool "PMS always checks the state group"
	depends on PMS
	default n
	help
	  Enable this option if the state group has to be controlled

config PMS_DEBUG
	bool "PMS debug"
	default n
	depends on PMS

config STM_MIPHY
	bool
	depends on SATA_STM
	default y if CPU_SUBTYPE_STX7105 
	default y if CPU_SUBTYPE_STX7108
	default y if CPU_SUBTYPE_STX7141
	default y if CPU_SUBTYPE_STX7200
	default n

endmenu
